/************************************************************************************/
/*  Program name CAPPOIMP_CONTROL_GROUP.sql                                */
/*  Creater:  CHAN BILLY KA KEUNG (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 24 MAY 2006				       First created                                    */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;
ALTER TRIGGER PO_CONTROL_GROUPS_CT1 DISABLE;
ALTER TRIGGER PO_CONTROL_GROUPS_CT2 DISABLE;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPPOIMP_CONTROL_GROUP';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_seq_id		NUMBER;
	
	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_PO_CONTROL_GROUP
	FOR UPDATE;
		
	
BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN
			
			SELECT PO_CONTROL_GROUPS_S.NEXTVAL
			INTO lv_seq_id
			FROM DUAL;
			
			UPDATE CRST_PO_CONTROL_GROUP
			SET CONTROL_GROUP_ID_N = lv_seq_id
			WHERE CONTROL_GROUP_ID = C1.CONTROL_GROUP_ID;
			
			INSERT INTO PO_CONTROL_GROUPS_ALL
			VALUES
			(
				lv_seq_id		       ,
				C1.CONTROL_GROUP_NAME     ,
				C1.LAST_UPDATE_DATE       ,
				C1.LAST_UPDATED_BY        ,
				C1.LAST_UPDATE_LOGIN      ,
				C1.CREATION_DATE          ,
				C1.CREATED_BY             ,
				C1.REQUEST_ID             ,
				C1.PROGRAM_APPLICATION_ID ,
				C1.PROGRAM_ID             ,
				C1.PROGRAM_UPDATE_DATE    ,
				C1.ENABLED_FLAG           ,
				C1.DESCRIPTION            , 
				C1.ATTRIBUTE1             ,
				C1.ATTRIBUTE10            ,
				C1.ATTRIBUTE11             ,
				C1.ATTRIBUTE12             ,
				C1.ATTRIBUTE13             ,
				C1.ATTRIBUTE14             ,
				C1.ATTRIBUTE15             ,
				C1.ATTRIBUTE2              ,
				C1.ATTRIBUTE3              ,
				C1.ATTRIBUTE4              ,
				C1.ATTRIBUTE5              ,
				C1.ATTRIBUTE6              ,
				C1.ATTRIBUTE7              ,
				C1.ATTRIBUTE8              ,
				C1.ATTRIBUTE9              ,
				C1.ATTRIBUTE_CATEGORY      ,
				CAPBRIMP_MAPPING.GetOrgMapping(C1.ORG_ID)
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	DBMS_OUTPUT.Put_Line(SQLERRM);
	DBMS_OUTPUT.Put_Line(lv_Err_Count);
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;
	
	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/
ALTER TRIGGER PO_CONTROL_GROUPS_CT1 ENABLE;
ALTER TRIGGER PO_CONTROL_GROUPS_CT2 ENABLE;
